// The MIT License (MIT)

// Copyright (c) 2017-2020 Uber Technologies Inc.

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: uber/cadence/shared/v1/replication.proto

package sharedv1

import (
	fmt "fmt"
	io "io"
	math "math"
	math_bits "math/bits"

	proto "github.com/gogo/protobuf/proto"
	types "github.com/gogo/protobuf/types"

	v1 "github.com/uber/cadence/.gen/proto/api/v1"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

type ReplicationTaskType int32

const (
	ReplicationTaskType_REPLICATION_TASK_TYPE_INVALID           ReplicationTaskType = 0
	ReplicationTaskType_REPLICATION_TASK_TYPE_DOMAIN            ReplicationTaskType = 1
	ReplicationTaskType_REPLICATION_TASK_TYPE_HISTORY           ReplicationTaskType = 2
	ReplicationTaskType_REPLICATION_TASK_TYPE_SYNC_SHARD_STATUS ReplicationTaskType = 3
	ReplicationTaskType_REPLICATION_TASK_TYPE_SYNC_ACTIVITY     ReplicationTaskType = 4
	ReplicationTaskType_REPLICATION_TASK_TYPE_HISTORY_METADATA  ReplicationTaskType = 5
	ReplicationTaskType_REPLICATION_TASK_TYPE_HISTORY_V2        ReplicationTaskType = 6
	ReplicationTaskType_REPLICATION_TASK_TYPE_FAILOVER_MARKER   ReplicationTaskType = 7
)

var ReplicationTaskType_name = map[int32]string{
	0: "REPLICATION_TASK_TYPE_INVALID",
	1: "REPLICATION_TASK_TYPE_DOMAIN",
	2: "REPLICATION_TASK_TYPE_HISTORY",
	3: "REPLICATION_TASK_TYPE_SYNC_SHARD_STATUS",
	4: "REPLICATION_TASK_TYPE_SYNC_ACTIVITY",
	5: "REPLICATION_TASK_TYPE_HISTORY_METADATA",
	6: "REPLICATION_TASK_TYPE_HISTORY_V2",
	7: "REPLICATION_TASK_TYPE_FAILOVER_MARKER",
}

var ReplicationTaskType_value = map[string]int32{
	"REPLICATION_TASK_TYPE_INVALID":           0,
	"REPLICATION_TASK_TYPE_DOMAIN":            1,
	"REPLICATION_TASK_TYPE_HISTORY":           2,
	"REPLICATION_TASK_TYPE_SYNC_SHARD_STATUS": 3,
	"REPLICATION_TASK_TYPE_SYNC_ACTIVITY":     4,
	"REPLICATION_TASK_TYPE_HISTORY_METADATA":  5,
	"REPLICATION_TASK_TYPE_HISTORY_V2":        6,
	"REPLICATION_TASK_TYPE_FAILOVER_MARKER":   7,
}

func (x ReplicationTaskType) String() string {
	return proto.EnumName(ReplicationTaskType_name, int32(x))
}

func (ReplicationTaskType) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_00df2ec6c2eaefe5, []int{0}
}

type DomainOperation int32

const (
	DomainOperation_DOMAIN_OPERATION_INVALID DomainOperation = 0
	DomainOperation_DOMAIN_OPERATION_CREATE  DomainOperation = 1
	DomainOperation_DOMAIN_OPERATION_UPDATE  DomainOperation = 2
)

var DomainOperation_name = map[int32]string{
	0: "DOMAIN_OPERATION_INVALID",
	1: "DOMAIN_OPERATION_CREATE",
	2: "DOMAIN_OPERATION_UPDATE",
}

var DomainOperation_value = map[string]int32{
	"DOMAIN_OPERATION_INVALID": 0,
	"DOMAIN_OPERATION_CREATE":  1,
	"DOMAIN_OPERATION_UPDATE":  2,
}

func (x DomainOperation) String() string {
	return proto.EnumName(DomainOperation_name, int32(x))
}

func (DomainOperation) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_00df2ec6c2eaefe5, []int{1}
}

type DLQType int32

const (
	DLQType_DLQ_TYPE_INVALID     DLQType = 0
	DLQType_DLQ_TYPE_REPLICATION DLQType = 1
	DLQType_DLQ_TYPE_DOMAIN      DLQType = 2
)

var DLQType_name = map[int32]string{
	0: "DLQ_TYPE_INVALID",
	1: "DLQ_TYPE_REPLICATION",
	2: "DLQ_TYPE_DOMAIN",
}

var DLQType_value = map[string]int32{
	"DLQ_TYPE_INVALID":     0,
	"DLQ_TYPE_REPLICATION": 1,
	"DLQ_TYPE_DOMAIN":      2,
}

func (x DLQType) String() string {
	return proto.EnumName(DLQType_name, int32(x))
}

func (DLQType) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_00df2ec6c2eaefe5, []int{2}
}

type ReplicationMessages struct {
	ReplicationTasks []*ReplicationTask `protobuf:"bytes,1,rep,name=replication_tasks,json=replicationTasks,proto3" json:"replication_tasks,omitempty"`
	// This can be different than the last taskId in the above list,
	//because sender can decide to skip tasks (e.g. for completed workflows).
	LastRetrievedMessageId int64 `protobuf:"varint,2,opt,name=last_retrieved_message_id,json=lastRetrievedMessageId,proto3" json:"last_retrieved_message_id,omitempty"`
	// Hint for flow control.
	HasMore              bool             `protobuf:"varint,3,opt,name=has_more,json=hasMore,proto3" json:"has_more,omitempty"`
	SyncShardStatus      *SyncShardStatus `protobuf:"bytes,4,opt,name=sync_shard_status,json=syncShardStatus,proto3" json:"sync_shard_status,omitempty"`
	XXX_NoUnkeyedLiteral struct{}         `json:"-"`
	XXX_unrecognized     []byte           `json:"-"`
	XXX_sizecache        int32            `json:"-"`
}

func (m *ReplicationMessages) Reset()         { *m = ReplicationMessages{} }
func (m *ReplicationMessages) String() string { return proto.CompactTextString(m) }
func (*ReplicationMessages) ProtoMessage()    {}
func (*ReplicationMessages) Descriptor() ([]byte, []int) {
	return fileDescriptor_00df2ec6c2eaefe5, []int{0}
}
func (m *ReplicationMessages) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *ReplicationMessages) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_ReplicationMessages.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *ReplicationMessages) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ReplicationMessages.Merge(m, src)
}
func (m *ReplicationMessages) XXX_Size() int {
	return m.Size()
}
func (m *ReplicationMessages) XXX_DiscardUnknown() {
	xxx_messageInfo_ReplicationMessages.DiscardUnknown(m)
}

var xxx_messageInfo_ReplicationMessages proto.InternalMessageInfo

func (m *ReplicationMessages) GetReplicationTasks() []*ReplicationTask {
	if m != nil {
		return m.ReplicationTasks
	}
	return nil
}

func (m *ReplicationMessages) GetLastRetrievedMessageId() int64 {
	if m != nil {
		return m.LastRetrievedMessageId
	}
	return 0
}

func (m *ReplicationMessages) GetHasMore() bool {
	if m != nil {
		return m.HasMore
	}
	return false
}

func (m *ReplicationMessages) GetSyncShardStatus() *SyncShardStatus {
	if m != nil {
		return m.SyncShardStatus
	}
	return nil
}

type ReplicationTask struct {
	TaskType     ReplicationTaskType `protobuf:"varint,1,opt,name=task_type,json=taskType,proto3,enum=uber.cadence.shared.v1.ReplicationTaskType" json:"task_type,omitempty"`
	SourceTaskId int64               `protobuf:"varint,2,opt,name=source_task_id,json=sourceTaskId,proto3" json:"source_task_id,omitempty"`
	CreationTime *types.Timestamp    `protobuf:"bytes,3,opt,name=creation_time,json=creationTime,proto3" json:"creation_time,omitempty"`
	// Types that are valid to be assigned to Attributes:
	//	*ReplicationTask_DomainTaskAttributes
	//	*ReplicationTask_SyncShardStatusTaskAttributes
	//	*ReplicationTask_SyncActivityTaskAttributes
	//	*ReplicationTask_HistoryTaskV2Attributes
	//	*ReplicationTask_FailoverMarkerAttributes
	Attributes           isReplicationTask_Attributes `protobuf_oneof:"attributes"`
	XXX_NoUnkeyedLiteral struct{}                     `json:"-"`
	XXX_unrecognized     []byte                       `json:"-"`
	XXX_sizecache        int32                        `json:"-"`
}

func (m *ReplicationTask) Reset()         { *m = ReplicationTask{} }
func (m *ReplicationTask) String() string { return proto.CompactTextString(m) }
func (*ReplicationTask) ProtoMessage()    {}
func (*ReplicationTask) Descriptor() ([]byte, []int) {
	return fileDescriptor_00df2ec6c2eaefe5, []int{1}
}
func (m *ReplicationTask) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *ReplicationTask) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_ReplicationTask.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *ReplicationTask) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ReplicationTask.Merge(m, src)
}
func (m *ReplicationTask) XXX_Size() int {
	return m.Size()
}
func (m *ReplicationTask) XXX_DiscardUnknown() {
	xxx_messageInfo_ReplicationTask.DiscardUnknown(m)
}

var xxx_messageInfo_ReplicationTask proto.InternalMessageInfo

type isReplicationTask_Attributes interface {
	isReplicationTask_Attributes()
	MarshalTo([]byte) (int, error)
	Size() int
}

type ReplicationTask_DomainTaskAttributes struct {
	DomainTaskAttributes *DomainTaskAttributes `protobuf:"bytes,4,opt,name=domain_task_attributes,json=domainTaskAttributes,proto3,oneof" json:"domain_task_attributes,omitempty"`
}
type ReplicationTask_SyncShardStatusTaskAttributes struct {
	SyncShardStatusTaskAttributes *SyncShardStatusTaskAttributes `protobuf:"bytes,5,opt,name=sync_shard_status_task_attributes,json=syncShardStatusTaskAttributes,proto3,oneof" json:"sync_shard_status_task_attributes,omitempty"`
}
type ReplicationTask_SyncActivityTaskAttributes struct {
	SyncActivityTaskAttributes *SyncActivityTaskAttributes `protobuf:"bytes,6,opt,name=sync_activity_task_attributes,json=syncActivityTaskAttributes,proto3,oneof" json:"sync_activity_task_attributes,omitempty"`
}
type ReplicationTask_HistoryTaskV2Attributes struct {
	HistoryTaskV2Attributes *HistoryTaskV2Attributes `protobuf:"bytes,7,opt,name=history_task_v2_attributes,json=historyTaskV2Attributes,proto3,oneof" json:"history_task_v2_attributes,omitempty"`
}
type ReplicationTask_FailoverMarkerAttributes struct {
	FailoverMarkerAttributes *FailoverMarkerAttributes `protobuf:"bytes,8,opt,name=failover_marker_attributes,json=failoverMarkerAttributes,proto3,oneof" json:"failover_marker_attributes,omitempty"`
}

func (*ReplicationTask_DomainTaskAttributes) isReplicationTask_Attributes()          {}
func (*ReplicationTask_SyncShardStatusTaskAttributes) isReplicationTask_Attributes() {}
func (*ReplicationTask_SyncActivityTaskAttributes) isReplicationTask_Attributes()    {}
func (*ReplicationTask_HistoryTaskV2Attributes) isReplicationTask_Attributes()       {}
func (*ReplicationTask_FailoverMarkerAttributes) isReplicationTask_Attributes()      {}

func (m *ReplicationTask) GetAttributes() isReplicationTask_Attributes {
	if m != nil {
		return m.Attributes
	}
	return nil
}

func (m *ReplicationTask) GetTaskType() ReplicationTaskType {
	if m != nil {
		return m.TaskType
	}
	return ReplicationTaskType_REPLICATION_TASK_TYPE_INVALID
}

func (m *ReplicationTask) GetSourceTaskId() int64 {
	if m != nil {
		return m.SourceTaskId
	}
	return 0
}

func (m *ReplicationTask) GetCreationTime() *types.Timestamp {
	if m != nil {
		return m.CreationTime
	}
	return nil
}

func (m *ReplicationTask) GetDomainTaskAttributes() *DomainTaskAttributes {
	if x, ok := m.GetAttributes().(*ReplicationTask_DomainTaskAttributes); ok {
		return x.DomainTaskAttributes
	}
	return nil
}

func (m *ReplicationTask) GetSyncShardStatusTaskAttributes() *SyncShardStatusTaskAttributes {
	if x, ok := m.GetAttributes().(*ReplicationTask_SyncShardStatusTaskAttributes); ok {
		return x.SyncShardStatusTaskAttributes
	}
	return nil
}

func (m *ReplicationTask) GetSyncActivityTaskAttributes() *SyncActivityTaskAttributes {
	if x, ok := m.GetAttributes().(*ReplicationTask_SyncActivityTaskAttributes); ok {
		return x.SyncActivityTaskAttributes
	}
	return nil
}

func (m *ReplicationTask) GetHistoryTaskV2Attributes() *HistoryTaskV2Attributes {
	if x, ok := m.GetAttributes().(*ReplicationTask_HistoryTaskV2Attributes); ok {
		return x.HistoryTaskV2Attributes
	}
	return nil
}

func (m *ReplicationTask) GetFailoverMarkerAttributes() *FailoverMarkerAttributes {
	if x, ok := m.GetAttributes().(*ReplicationTask_FailoverMarkerAttributes); ok {
		return x.FailoverMarkerAttributes
	}
	return nil
}

// XXX_OneofWrappers is for the internal use of the proto package.
func (*ReplicationTask) XXX_OneofWrappers() []interface{} {
	return []interface{}{
		(*ReplicationTask_DomainTaskAttributes)(nil),
		(*ReplicationTask_SyncShardStatusTaskAttributes)(nil),
		(*ReplicationTask_SyncActivityTaskAttributes)(nil),
		(*ReplicationTask_HistoryTaskV2Attributes)(nil),
		(*ReplicationTask_FailoverMarkerAttributes)(nil),
	}
}

type DomainTaskAttributes struct {
	DomainOperation         DomainOperation `protobuf:"varint,1,opt,name=domain_operation,json=domainOperation,proto3,enum=uber.cadence.shared.v1.DomainOperation" json:"domain_operation,omitempty"`
	Id                      string          `protobuf:"bytes,2,opt,name=id,proto3" json:"id,omitempty"`
	Domain                  *v1.Domain      `protobuf:"bytes,3,opt,name=domain,proto3" json:"domain,omitempty"`
	ConfigVersion           int64           `protobuf:"varint,4,opt,name=config_version,json=configVersion,proto3" json:"config_version,omitempty"`
	FailoverVersion         int64           `protobuf:"varint,5,opt,name=failover_version,json=failoverVersion,proto3" json:"failover_version,omitempty"`
	PreviousFailoverVersion int64           `protobuf:"varint,6,opt,name=previous_failover_version,json=previousFailoverVersion,proto3" json:"previous_failover_version,omitempty"`
	XXX_NoUnkeyedLiteral    struct{}        `json:"-"`
	XXX_unrecognized        []byte          `json:"-"`
	XXX_sizecache           int32           `json:"-"`
}

func (m *DomainTaskAttributes) Reset()         { *m = DomainTaskAttributes{} }
func (m *DomainTaskAttributes) String() string { return proto.CompactTextString(m) }
func (*DomainTaskAttributes) ProtoMessage()    {}
func (*DomainTaskAttributes) Descriptor() ([]byte, []int) {
	return fileDescriptor_00df2ec6c2eaefe5, []int{2}
}
func (m *DomainTaskAttributes) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *DomainTaskAttributes) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_DomainTaskAttributes.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *DomainTaskAttributes) XXX_Merge(src proto.Message) {
	xxx_messageInfo_DomainTaskAttributes.Merge(m, src)
}
func (m *DomainTaskAttributes) XXX_Size() int {
	return m.Size()
}
func (m *DomainTaskAttributes) XXX_DiscardUnknown() {
	xxx_messageInfo_DomainTaskAttributes.DiscardUnknown(m)
}

var xxx_messageInfo_DomainTaskAttributes proto.InternalMessageInfo

func (m *DomainTaskAttributes) GetDomainOperation() DomainOperation {
	if m != nil {
		return m.DomainOperation
	}
	return DomainOperation_DOMAIN_OPERATION_INVALID
}

func (m *DomainTaskAttributes) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func (m *DomainTaskAttributes) GetDomain() *v1.Domain {
	if m != nil {
		return m.Domain
	}
	return nil
}

func (m *DomainTaskAttributes) GetConfigVersion() int64 {
	if m != nil {
		return m.ConfigVersion
	}
	return 0
}

func (m *DomainTaskAttributes) GetFailoverVersion() int64 {
	if m != nil {
		return m.FailoverVersion
	}
	return 0
}

func (m *DomainTaskAttributes) GetPreviousFailoverVersion() int64 {
	if m != nil {
		return m.PreviousFailoverVersion
	}
	return 0
}

type SyncShardStatusTaskAttributes struct {
	SourceCluster        string           `protobuf:"bytes,1,opt,name=source_cluster,json=sourceCluster,proto3" json:"source_cluster,omitempty"`
	ShardId              int32            `protobuf:"varint,2,opt,name=shard_id,json=shardId,proto3" json:"shard_id,omitempty"`
	Timestamp            *types.Timestamp `protobuf:"bytes,3,opt,name=timestamp,proto3" json:"timestamp,omitempty"`
	XXX_NoUnkeyedLiteral struct{}         `json:"-"`
	XXX_unrecognized     []byte           `json:"-"`
	XXX_sizecache        int32            `json:"-"`
}

func (m *SyncShardStatusTaskAttributes) Reset()         { *m = SyncShardStatusTaskAttributes{} }
func (m *SyncShardStatusTaskAttributes) String() string { return proto.CompactTextString(m) }
func (*SyncShardStatusTaskAttributes) ProtoMessage()    {}
func (*SyncShardStatusTaskAttributes) Descriptor() ([]byte, []int) {
	return fileDescriptor_00df2ec6c2eaefe5, []int{3}
}
func (m *SyncShardStatusTaskAttributes) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *SyncShardStatusTaskAttributes) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_SyncShardStatusTaskAttributes.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *SyncShardStatusTaskAttributes) XXX_Merge(src proto.Message) {
	xxx_messageInfo_SyncShardStatusTaskAttributes.Merge(m, src)
}
func (m *SyncShardStatusTaskAttributes) XXX_Size() int {
	return m.Size()
}
func (m *SyncShardStatusTaskAttributes) XXX_DiscardUnknown() {
	xxx_messageInfo_SyncShardStatusTaskAttributes.DiscardUnknown(m)
}

var xxx_messageInfo_SyncShardStatusTaskAttributes proto.InternalMessageInfo

func (m *SyncShardStatusTaskAttributes) GetSourceCluster() string {
	if m != nil {
		return m.SourceCluster
	}
	return ""
}

func (m *SyncShardStatusTaskAttributes) GetShardId() int32 {
	if m != nil {
		return m.ShardId
	}
	return 0
}

func (m *SyncShardStatusTaskAttributes) GetTimestamp() *types.Timestamp {
	if m != nil {
		return m.Timestamp
	}
	return nil
}

type SyncActivityTaskAttributes struct {
	DomainId             string                `protobuf:"bytes,1,opt,name=domain_id,json=domainId,proto3" json:"domain_id,omitempty"`
	WorkflowExecution    *v1.WorkflowExecution `protobuf:"bytes,2,opt,name=workflow_execution,json=workflowExecution,proto3" json:"workflow_execution,omitempty"`
	Version              int64                 `protobuf:"varint,3,opt,name=version,proto3" json:"version,omitempty"`
	ScheduledId          int64                 `protobuf:"varint,4,opt,name=scheduled_id,json=scheduledId,proto3" json:"scheduled_id,omitempty"`
	ScheduledTime        *types.Timestamp      `protobuf:"bytes,5,opt,name=scheduled_time,json=scheduledTime,proto3" json:"scheduled_time,omitempty"`
	StartedId            int64                 `protobuf:"varint,6,opt,name=started_id,json=startedId,proto3" json:"started_id,omitempty"`
	StartedTime          *types.Timestamp      `protobuf:"bytes,7,opt,name=started_time,json=startedTime,proto3" json:"started_time,omitempty"`
	LastHeartbeatTime    *types.Timestamp      `protobuf:"bytes,8,opt,name=last_heartbeat_time,json=lastHeartbeatTime,proto3" json:"last_heartbeat_time,omitempty"`
	Details              *v1.Payload           `protobuf:"bytes,9,opt,name=details,proto3" json:"details,omitempty"`
	Attempt              int32                 `protobuf:"varint,10,opt,name=attempt,proto3" json:"attempt,omitempty"`
	LastFailure          *v1.Failure           `protobuf:"bytes,11,opt,name=last_failure,json=lastFailure,proto3" json:"last_failure,omitempty"`
	LastWorkerIdentity   string                `protobuf:"bytes,12,opt,name=last_worker_identity,json=lastWorkerIdentity,proto3" json:"last_worker_identity,omitempty"`
	VersionHistory       *VersionHistory       `protobuf:"bytes,13,opt,name=version_history,json=versionHistory,proto3" json:"version_history,omitempty"`
	XXX_NoUnkeyedLiteral struct{}              `json:"-"`
	XXX_unrecognized     []byte                `json:"-"`
	XXX_sizecache        int32                 `json:"-"`
}

func (m *SyncActivityTaskAttributes) Reset()         { *m = SyncActivityTaskAttributes{} }
func (m *SyncActivityTaskAttributes) String() string { return proto.CompactTextString(m) }
func (*SyncActivityTaskAttributes) ProtoMessage()    {}
func (*SyncActivityTaskAttributes) Descriptor() ([]byte, []int) {
	return fileDescriptor_00df2ec6c2eaefe5, []int{4}
}
func (m *SyncActivityTaskAttributes) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *SyncActivityTaskAttributes) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_SyncActivityTaskAttributes.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *SyncActivityTaskAttributes) XXX_Merge(src proto.Message) {
	xxx_messageInfo_SyncActivityTaskAttributes.Merge(m, src)
}
func (m *SyncActivityTaskAttributes) XXX_Size() int {
	return m.Size()
}
func (m *SyncActivityTaskAttributes) XXX_DiscardUnknown() {
	xxx_messageInfo_SyncActivityTaskAttributes.DiscardUnknown(m)
}

var xxx_messageInfo_SyncActivityTaskAttributes proto.InternalMessageInfo

func (m *SyncActivityTaskAttributes) GetDomainId() string {
	if m != nil {
		return m.DomainId
	}
	return ""
}

func (m *SyncActivityTaskAttributes) GetWorkflowExecution() *v1.WorkflowExecution {
	if m != nil {
		return m.WorkflowExecution
	}
	return nil
}

func (m *SyncActivityTaskAttributes) GetVersion() int64 {
	if m != nil {
		return m.Version
	}
	return 0
}

func (m *SyncActivityTaskAttributes) GetScheduledId() int64 {
	if m != nil {
		return m.ScheduledId
	}
	return 0
}

func (m *SyncActivityTaskAttributes) GetScheduledTime() *types.Timestamp {
	if m != nil {
		return m.ScheduledTime
	}
	return nil
}

func (m *SyncActivityTaskAttributes) GetStartedId() int64 {
	if m != nil {
		return m.StartedId
	}
	return 0
}

func (m *SyncActivityTaskAttributes) GetStartedTime() *types.Timestamp {
	if m != nil {
		return m.StartedTime
	}
	return nil
}

func (m *SyncActivityTaskAttributes) GetLastHeartbeatTime() *types.Timestamp {
	if m != nil {
		return m.LastHeartbeatTime
	}
	return nil
}

func (m *SyncActivityTaskAttributes) GetDetails() *v1.Payload {
	if m != nil {
		return m.Details
	}
	return nil
}

func (m *SyncActivityTaskAttributes) GetAttempt() int32 {
	if m != nil {
		return m.Attempt
	}
	return 0
}

func (m *SyncActivityTaskAttributes) GetLastFailure() *v1.Failure {
	if m != nil {
		return m.LastFailure
	}
	return nil
}

func (m *SyncActivityTaskAttributes) GetLastWorkerIdentity() string {
	if m != nil {
		return m.LastWorkerIdentity
	}
	return ""
}

func (m *SyncActivityTaskAttributes) GetVersionHistory() *VersionHistory {
	if m != nil {
		return m.VersionHistory
	}
	return nil
}

type HistoryTaskV2Attributes struct {
	TaskId              int64                 `protobuf:"varint,1,opt,name=task_id,json=taskId,proto3" json:"task_id,omitempty"`
	DomainId            string                `protobuf:"bytes,2,opt,name=domain_id,json=domainId,proto3" json:"domain_id,omitempty"`
	WorkflowExecution   *v1.WorkflowExecution `protobuf:"bytes,3,opt,name=workflow_execution,json=workflowExecution,proto3" json:"workflow_execution,omitempty"`
	VersionHistoryItems []*VersionHistoryItem `protobuf:"bytes,4,rep,name=version_history_items,json=versionHistoryItems,proto3" json:"version_history_items,omitempty"`
	Events              *v1.DataBlob          `protobuf:"bytes,5,opt,name=events,proto3" json:"events,omitempty"`
	// New run events does not need version history since there is no prior events.
	NewRunEvents         *v1.DataBlob `protobuf:"bytes,6,opt,name=new_run_events,json=newRunEvents,proto3" json:"new_run_events,omitempty"`
	XXX_NoUnkeyedLiteral struct{}     `json:"-"`
	XXX_unrecognized     []byte       `json:"-"`
	XXX_sizecache        int32        `json:"-"`
}

func (m *HistoryTaskV2Attributes) Reset()         { *m = HistoryTaskV2Attributes{} }
func (m *HistoryTaskV2Attributes) String() string { return proto.CompactTextString(m) }
func (*HistoryTaskV2Attributes) ProtoMessage()    {}
func (*HistoryTaskV2Attributes) Descriptor() ([]byte, []int) {
	return fileDescriptor_00df2ec6c2eaefe5, []int{5}
}
func (m *HistoryTaskV2Attributes) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *HistoryTaskV2Attributes) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_HistoryTaskV2Attributes.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *HistoryTaskV2Attributes) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HistoryTaskV2Attributes.Merge(m, src)
}
func (m *HistoryTaskV2Attributes) XXX_Size() int {
	return m.Size()
}
func (m *HistoryTaskV2Attributes) XXX_DiscardUnknown() {
	xxx_messageInfo_HistoryTaskV2Attributes.DiscardUnknown(m)
}

var xxx_messageInfo_HistoryTaskV2Attributes proto.InternalMessageInfo

func (m *HistoryTaskV2Attributes) GetTaskId() int64 {
	if m != nil {
		return m.TaskId
	}
	return 0
}

func (m *HistoryTaskV2Attributes) GetDomainId() string {
	if m != nil {
		return m.DomainId
	}
	return ""
}

func (m *HistoryTaskV2Attributes) GetWorkflowExecution() *v1.WorkflowExecution {
	if m != nil {
		return m.WorkflowExecution
	}
	return nil
}

func (m *HistoryTaskV2Attributes) GetVersionHistoryItems() []*VersionHistoryItem {
	if m != nil {
		return m.VersionHistoryItems
	}
	return nil
}

func (m *HistoryTaskV2Attributes) GetEvents() *v1.DataBlob {
	if m != nil {
		return m.Events
	}
	return nil
}

func (m *HistoryTaskV2Attributes) GetNewRunEvents() *v1.DataBlob {
	if m != nil {
		return m.NewRunEvents
	}
	return nil
}

type FailoverMarkerAttributes struct {
	DomainId             string           `protobuf:"bytes,1,opt,name=domain_id,json=domainId,proto3" json:"domain_id,omitempty"`
	FailoverVersion      int64            `protobuf:"varint,2,opt,name=failover_version,json=failoverVersion,proto3" json:"failover_version,omitempty"`
	CreationTime         *types.Timestamp `protobuf:"bytes,3,opt,name=creation_time,json=creationTime,proto3" json:"creation_time,omitempty"`
	XXX_NoUnkeyedLiteral struct{}         `json:"-"`
	XXX_unrecognized     []byte           `json:"-"`
	XXX_sizecache        int32            `json:"-"`
}

func (m *FailoverMarkerAttributes) Reset()         { *m = FailoverMarkerAttributes{} }
func (m *FailoverMarkerAttributes) String() string { return proto.CompactTextString(m) }
func (*FailoverMarkerAttributes) ProtoMessage()    {}
func (*FailoverMarkerAttributes) Descriptor() ([]byte, []int) {
	return fileDescriptor_00df2ec6c2eaefe5, []int{6}
}
func (m *FailoverMarkerAttributes) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *FailoverMarkerAttributes) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_FailoverMarkerAttributes.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *FailoverMarkerAttributes) XXX_Merge(src proto.Message) {
	xxx_messageInfo_FailoverMarkerAttributes.Merge(m, src)
}
func (m *FailoverMarkerAttributes) XXX_Size() int {
	return m.Size()
}
func (m *FailoverMarkerAttributes) XXX_DiscardUnknown() {
	xxx_messageInfo_FailoverMarkerAttributes.DiscardUnknown(m)
}

var xxx_messageInfo_FailoverMarkerAttributes proto.InternalMessageInfo

func (m *FailoverMarkerAttributes) GetDomainId() string {
	if m != nil {
		return m.DomainId
	}
	return ""
}

func (m *FailoverMarkerAttributes) GetFailoverVersion() int64 {
	if m != nil {
		return m.FailoverVersion
	}
	return 0
}

func (m *FailoverMarkerAttributes) GetCreationTime() *types.Timestamp {
	if m != nil {
		return m.CreationTime
	}
	return nil
}

type FailoverMarkerToken struct {
	ShardIds             []int32                   `protobuf:"varint,1,rep,packed,name=shard_ids,json=shardIds,proto3" json:"shard_ids,omitempty"`
	FailoverMarker       *FailoverMarkerAttributes `protobuf:"bytes,2,opt,name=failover_marker,json=failoverMarker,proto3" json:"failover_marker,omitempty"`
	XXX_NoUnkeyedLiteral struct{}                  `json:"-"`
	XXX_unrecognized     []byte                    `json:"-"`
	XXX_sizecache        int32                     `json:"-"`
}

func (m *FailoverMarkerToken) Reset()         { *m = FailoverMarkerToken{} }
func (m *FailoverMarkerToken) String() string { return proto.CompactTextString(m) }
func (*FailoverMarkerToken) ProtoMessage()    {}
func (*FailoverMarkerToken) Descriptor() ([]byte, []int) {
	return fileDescriptor_00df2ec6c2eaefe5, []int{7}
}
func (m *FailoverMarkerToken) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *FailoverMarkerToken) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_FailoverMarkerToken.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *FailoverMarkerToken) XXX_Merge(src proto.Message) {
	xxx_messageInfo_FailoverMarkerToken.Merge(m, src)
}
func (m *FailoverMarkerToken) XXX_Size() int {
	return m.Size()
}
func (m *FailoverMarkerToken) XXX_DiscardUnknown() {
	xxx_messageInfo_FailoverMarkerToken.DiscardUnknown(m)
}

var xxx_messageInfo_FailoverMarkerToken proto.InternalMessageInfo

func (m *FailoverMarkerToken) GetShardIds() []int32 {
	if m != nil {
		return m.ShardIds
	}
	return nil
}

func (m *FailoverMarkerToken) GetFailoverMarker() *FailoverMarkerAttributes {
	if m != nil {
		return m.FailoverMarker
	}
	return nil
}

type ReplicationTaskInfo struct {
	DomainId             string                `protobuf:"bytes,1,opt,name=domain_id,json=domainId,proto3" json:"domain_id,omitempty"`
	WorkflowExecution    *v1.WorkflowExecution `protobuf:"bytes,2,opt,name=workflow_execution,json=workflowExecution,proto3" json:"workflow_execution,omitempty"`
	TaskType             int32                 `protobuf:"varint,3,opt,name=task_type,json=taskType,proto3" json:"task_type,omitempty"`
	TaskId               int64                 `protobuf:"varint,4,opt,name=task_id,json=taskId,proto3" json:"task_id,omitempty"`
	Version              int64                 `protobuf:"varint,5,opt,name=version,proto3" json:"version,omitempty"`
	FirstEventId         int64                 `protobuf:"varint,6,opt,name=first_event_id,json=firstEventId,proto3" json:"first_event_id,omitempty"`
	NextEventId          int64                 `protobuf:"varint,7,opt,name=next_event_id,json=nextEventId,proto3" json:"next_event_id,omitempty"`
	ScheduledId          int64                 `protobuf:"varint,8,opt,name=scheduled_id,json=scheduledId,proto3" json:"scheduled_id,omitempty"`
	XXX_NoUnkeyedLiteral struct{}              `json:"-"`
	XXX_unrecognized     []byte                `json:"-"`
	XXX_sizecache        int32                 `json:"-"`
}

func (m *ReplicationTaskInfo) Reset()         { *m = ReplicationTaskInfo{} }
func (m *ReplicationTaskInfo) String() string { return proto.CompactTextString(m) }
func (*ReplicationTaskInfo) ProtoMessage()    {}
func (*ReplicationTaskInfo) Descriptor() ([]byte, []int) {
	return fileDescriptor_00df2ec6c2eaefe5, []int{8}
}
func (m *ReplicationTaskInfo) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *ReplicationTaskInfo) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_ReplicationTaskInfo.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *ReplicationTaskInfo) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ReplicationTaskInfo.Merge(m, src)
}
func (m *ReplicationTaskInfo) XXX_Size() int {
	return m.Size()
}
func (m *ReplicationTaskInfo) XXX_DiscardUnknown() {
	xxx_messageInfo_ReplicationTaskInfo.DiscardUnknown(m)
}

var xxx_messageInfo_ReplicationTaskInfo proto.InternalMessageInfo

func (m *ReplicationTaskInfo) GetDomainId() string {
	if m != nil {
		return m.DomainId
	}
	return ""
}

func (m *ReplicationTaskInfo) GetWorkflowExecution() *v1.WorkflowExecution {
	if m != nil {
		return m.WorkflowExecution
	}
	return nil
}

func (m *ReplicationTaskInfo) GetTaskType() int32 {
	if m != nil {
		return m.TaskType
	}
	return 0
}

func (m *ReplicationTaskInfo) GetTaskId() int64 {
	if m != nil {
		return m.TaskId
	}
	return 0
}

func (m *ReplicationTaskInfo) GetVersion() int64 {
	if m != nil {
		return m.Version
	}
	return 0
}

func (m *ReplicationTaskInfo) GetFirstEventId() int64 {
	if m != nil {
		return m.FirstEventId
	}
	return 0
}

func (m *ReplicationTaskInfo) GetNextEventId() int64 {
	if m != nil {
		return m.NextEventId
	}
	return 0
}

func (m *ReplicationTaskInfo) GetScheduledId() int64 {
	if m != nil {
		return m.ScheduledId
	}
	return 0
}

type ReplicationToken struct {
	ShardId int32 `protobuf:"varint,1,opt,name=shard_id,json=shardId,proto3" json:"shard_id,omitempty"`
	// lastRetrievedMessageId is where the next fetch should begin with.
	LastRetrievedMessageId int64 `protobuf:"varint,2,opt,name=last_retrieved_message_id,json=lastRetrievedMessageId,proto3" json:"last_retrieved_message_id,omitempty"`
	// lastProcessedMessageId is the last messageId that is processed on the passive side.
	// This can be different than lastRetrievedMessageId if passive side supports prefetching messages.
	LastProcessedMessageId int64    `protobuf:"varint,3,opt,name=last_processed_message_id,json=lastProcessedMessageId,proto3" json:"last_processed_message_id,omitempty"`
	XXX_NoUnkeyedLiteral   struct{} `json:"-"`
	XXX_unrecognized       []byte   `json:"-"`
	XXX_sizecache          int32    `json:"-"`
}

func (m *ReplicationToken) Reset()         { *m = ReplicationToken{} }
func (m *ReplicationToken) String() string { return proto.CompactTextString(m) }
func (*ReplicationToken) ProtoMessage()    {}
func (*ReplicationToken) Descriptor() ([]byte, []int) {
	return fileDescriptor_00df2ec6c2eaefe5, []int{9}
}
func (m *ReplicationToken) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *ReplicationToken) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_ReplicationToken.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *ReplicationToken) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ReplicationToken.Merge(m, src)
}
func (m *ReplicationToken) XXX_Size() int {
	return m.Size()
}
func (m *ReplicationToken) XXX_DiscardUnknown() {
	xxx_messageInfo_ReplicationToken.DiscardUnknown(m)
}

var xxx_messageInfo_ReplicationToken proto.InternalMessageInfo

func (m *ReplicationToken) GetShardId() int32 {
	if m != nil {
		return m.ShardId
	}
	return 0
}

func (m *ReplicationToken) GetLastRetrievedMessageId() int64 {
	if m != nil {
		return m.LastRetrievedMessageId
	}
	return 0
}

func (m *ReplicationToken) GetLastProcessedMessageId() int64 {
	if m != nil {
		return m.LastProcessedMessageId
	}
	return 0
}

type SyncShardStatus struct {
	Timestamp            *types.Timestamp `protobuf:"bytes,1,opt,name=timestamp,proto3" json:"timestamp,omitempty"`
	XXX_NoUnkeyedLiteral struct{}         `json:"-"`
	XXX_unrecognized     []byte           `json:"-"`
	XXX_sizecache        int32            `json:"-"`
}

func (m *SyncShardStatus) Reset()         { *m = SyncShardStatus{} }
func (m *SyncShardStatus) String() string { return proto.CompactTextString(m) }
func (*SyncShardStatus) ProtoMessage()    {}
func (*SyncShardStatus) Descriptor() ([]byte, []int) {
	return fileDescriptor_00df2ec6c2eaefe5, []int{10}
}
func (m *SyncShardStatus) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *SyncShardStatus) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_SyncShardStatus.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *SyncShardStatus) XXX_Merge(src proto.Message) {
	xxx_messageInfo_SyncShardStatus.Merge(m, src)
}
func (m *SyncShardStatus) XXX_Size() int {
	return m.Size()
}
func (m *SyncShardStatus) XXX_DiscardUnknown() {
	xxx_messageInfo_SyncShardStatus.DiscardUnknown(m)
}

var xxx_messageInfo_SyncShardStatus proto.InternalMessageInfo

func (m *SyncShardStatus) GetTimestamp() *types.Timestamp {
	if m != nil {
		return m.Timestamp
	}
	return nil
}

func init() {
	proto.RegisterEnum("uber.cadence.shared.v1.ReplicationTaskType", ReplicationTaskType_name, ReplicationTaskType_value)
	proto.RegisterEnum("uber.cadence.shared.v1.DomainOperation", DomainOperation_name, DomainOperation_value)
	proto.RegisterEnum("uber.cadence.shared.v1.DLQType", DLQType_name, DLQType_value)
	proto.RegisterType((*ReplicationMessages)(nil), "uber.cadence.shared.v1.ReplicationMessages")
	proto.RegisterType((*ReplicationTask)(nil), "uber.cadence.shared.v1.ReplicationTask")
	proto.RegisterType((*DomainTaskAttributes)(nil), "uber.cadence.shared.v1.DomainTaskAttributes")
	proto.RegisterType((*SyncShardStatusTaskAttributes)(nil), "uber.cadence.shared.v1.SyncShardStatusTaskAttributes")
	proto.RegisterType((*SyncActivityTaskAttributes)(nil), "uber.cadence.shared.v1.SyncActivityTaskAttributes")
	proto.RegisterType((*HistoryTaskV2Attributes)(nil), "uber.cadence.shared.v1.HistoryTaskV2Attributes")
	proto.RegisterType((*FailoverMarkerAttributes)(nil), "uber.cadence.shared.v1.FailoverMarkerAttributes")
	proto.RegisterType((*FailoverMarkerToken)(nil), "uber.cadence.shared.v1.FailoverMarkerToken")
	proto.RegisterType((*ReplicationTaskInfo)(nil), "uber.cadence.shared.v1.ReplicationTaskInfo")
	proto.RegisterType((*ReplicationToken)(nil), "uber.cadence.shared.v1.ReplicationToken")
	proto.RegisterType((*SyncShardStatus)(nil), "uber.cadence.shared.v1.SyncShardStatus")
}

func init() {
	proto.RegisterFile("uber/cadence/shared/v1/replication.proto", fileDescriptor_00df2ec6c2eaefe5)
}

var fileDescriptor_00df2ec6c2eaefe5 = []byte{
	// 1506 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xc4, 0x58, 0xcd, 0x72, 0x1a, 0x49,
	0x12, 0x76, 0x83, 0xf8, 0x51, 0x0a, 0x01, 0x2a, 0x69, 0x2d, 0x2c, 0x59, 0x5e, 0xcc, 0xca, 0x96,
	0x2c, 0x6f, 0x80, 0x2d, 0x87, 0x37, 0xf6, 0x27, 0x36, 0x1c, 0x6d, 0x81, 0x42, 0xbd, 0xd6, 0x9f,
	0x8b, 0xb6, 0x1c, 0xda, 0xc3, 0x74, 0xb4, 0xe8, 0x92, 0xe8, 0x10, 0x74, 0x13, 0x5d, 0x05, 0x32,
	0xc7, 0x99, 0xfb, 0x1c, 0x67, 0x2e, 0x73, 0x9c, 0xe7, 0x98, 0xeb, 0xc4, 0x1c, 0xfd, 0x08, 0x13,
	0x7e, 0x92, 0x89, 0xae, 0xaa, 0x06, 0x1a, 0x1a, 0x2c, 0x87, 0x0f, 0x73, 0x53, 0x67, 0x7e, 0x5f,
	0x66, 0x56, 0x66, 0x56, 0x66, 0x09, 0xd8, 0xee, 0x5e, 0x10, 0xaf, 0xd2, 0x30, 0x2d, 0xe2, 0x34,
	0x48, 0x85, 0x36, 0x4d, 0x8f, 0x58, 0x95, 0xde, 0xf3, 0x8a, 0x47, 0x3a, 0x2d, 0xbb, 0x61, 0x32,
	0xdb, 0x75, 0xca, 0x1d, 0xcf, 0x65, 0x2e, 0xba, 0xeb, 0x23, 0xcb, 0x12, 0x59, 0x16, 0xc8, 0x72,
	0xef, 0xf9, 0xda, 0x5f, 0xaf, 0x5c, 0xf7, 0xaa, 0x45, 0x2a, 0x1c, 0x75, 0xd1, 0xbd, 0xac, 0x30,
	0xbb, 0x4d, 0x28, 0x33, 0xdb, 0x1d, 0x41, 0x5c, 0x2b, 0x86, 0x5c, 0x98, 0x1d, 0xdb, 0xb7, 0xdf,
	0x70, 0xdb, 0xed, 0xc0, 0x74, 0x34, 0xc2, 0x72, 0xdb, 0xa6, 0x1d, 0x20, 0x36, 0xa7, 0x84, 0xd9,
	0xb4, 0x29, 0x73, 0xbd, 0xbe, 0x40, 0x95, 0x7e, 0x8c, 0xc1, 0x32, 0x1e, 0x06, 0x7e, 0x44, 0x28,
	0x35, 0xaf, 0x08, 0x45, 0x3a, 0x2c, 0x8d, 0x9c, 0xc7, 0x60, 0x26, 0xbd, 0xa6, 0x05, 0xa5, 0x18,
	0xdf, 0x5e, 0xd8, 0xdd, 0x2a, 0x47, 0x1f, 0xab, 0x3c, 0x62, 0x47, 0x37, 0xe9, 0x35, 0xce, 0x7b,
	0x61, 0x01, 0x45, 0xff, 0x82, 0x7b, 0x2d, 0x93, 0x32, 0xc3, 0x23, 0xcc, 0xb3, 0x49, 0x8f, 0x58,
	0x46, 0x5b, 0x38, 0x34, 0x6c, 0xab, 0x10, 0x2b, 0x2a, 0xdb, 0x71, 0x7c, 0xd7, 0x07, 0xe0, 0x40,
	0x2f, 0xe3, 0xd1, 0x2c, 0x74, 0x0f, 0xd2, 0x4d, 0x93, 0x1a, 0x6d, 0xd7, 0x23, 0x85, 0x78, 0x51,
	0xd9, 0x4e, 0xe3, 0x54, 0xd3, 0xa4, 0x47, 0xae, 0x47, 0x50, 0x1d, 0x96, 0x68, 0xdf, 0x69, 0x18,
	0x7e, 0x24, 0x96, 0x41, 0x99, 0xc9, 0xba, 0xb4, 0x30, 0x57, 0x54, 0x66, 0xc5, 0x5a, 0xef, 0x3b,
	0x8d, 0xba, 0x8f, 0xaf, 0x73, 0x38, 0xce, 0xd1, 0xb0, 0xa0, 0xf4, 0x43, 0x12, 0x72, 0x63, 0x07,
	0x42, 0x07, 0x30, 0xef, 0x27, 0xc2, 0x60, 0xfd, 0x0e, 0x29, 0x28, 0x45, 0x65, 0x3b, 0xbb, 0xfb,
	0xf4, 0x96, 0xc9, 0xd0, 0xfb, 0x1d, 0x82, 0xd3, 0x4c, 0xfe, 0x85, 0x36, 0x21, 0x4b, 0xdd, 0xae,
	0xd7, 0x20, 0x3c, 0xb3, 0xc3, 0xd3, 0x67, 0x84, 0xd4, 0x67, 0x68, 0x16, 0x7a, 0x05, 0x8b, 0x0d,
	0x8f, 0xc8, 0x0a, 0xd8, 0x6d, 0x71, 0xf0, 0x85, 0xdd, 0xb5, 0xb2, 0xe8, 0x9f, 0x72, 0xd0, 0x3f,
	0x65, 0x3d, 0xe8, 0x1f, 0x9c, 0x09, 0x08, 0xbe, 0x08, 0x59, 0x70, 0x57, 0xf4, 0x84, 0x70, 0x63,
	0x32, 0xe6, 0xd9, 0x17, 0x5d, 0x46, 0x82, 0xf4, 0xfc, 0x7d, 0x5a, 0xf4, 0x55, 0xce, 0xf2, 0xc3,
	0x50, 0x07, 0x9c, 0x83, 0x3b, 0x78, 0xc5, 0x8a, 0x90, 0xa3, 0x6f, 0x15, 0x78, 0x38, 0x51, 0x80,
	0x09, 0x8f, 0x09, 0xee, 0xf1, 0xe5, 0x2d, 0x0b, 0x32, 0xe1, 0x7a, 0x83, 0xce, 0x02, 0xa0, 0x1b,
	0xe0, 0x00, 0xc3, 0x6c, 0x30, 0xbb, 0x67, 0xb3, 0xfe, 0x84, 0xfb, 0x24, 0x77, 0xbf, 0x3b, 0xcb,
	0xbd, 0x2a, 0xb9, 0x13, 0xbe, 0xd7, 0xe8, 0x54, 0x2d, 0x72, 0x60, 0x4d, 0xde, 0x28, 0xe1, 0xb2,
	0xb7, 0x3b, 0xea, 0x35, 0xc5, 0xbd, 0x56, 0xa6, 0x79, 0x3d, 0x10, 0x4c, 0xdf, 0xe4, 0xd9, 0x6e,
	0xc8, 0xe5, 0x6a, 0x33, 0x5a, 0x85, 0x3a, 0xb0, 0x76, 0x69, 0xda, 0x2d, 0xb7, 0x47, 0x3c, 0xa3,
	0x6d, 0x7a, 0xd7, 0xc4, 0x1b, 0xf5, 0x97, 0xe6, 0xfe, 0x9e, 0x4d, 0xf3, 0xb7, 0x2f, 0x99, 0x47,
	0x9c, 0x18, 0x72, 0x58, 0xb8, 0x9c, 0xa2, 0x7b, 0x9d, 0x01, 0x18, 0x7a, 0x28, 0xfd, 0x12, 0x83,
	0x95, 0xa8, 0xee, 0x40, 0x18, 0xf2, 0xb2, 0xd7, 0xdc, 0x0e, 0xf1, 0x78, 0x0f, 0xca, 0x3b, 0xb2,
	0x35, 0xbb, 0xcb, 0x4e, 0x02, 0x38, 0xce, 0x59, 0x61, 0x01, 0xca, 0x42, 0x4c, 0x5e, 0x8d, 0x79,
	0x1c, 0xb3, 0x2d, 0xf4, 0x02, 0x92, 0x02, 0x22, 0x6f, 0xc2, 0x7a, 0xd8, 0xb2, 0xd9, 0xb1, 0x87,
	0x66, 0xb1, 0x84, 0xa2, 0x47, 0x90, 0x6d, 0xb8, 0xce, 0xa5, 0x7d, 0x65, 0xf4, 0x88, 0x47, 0xfd,
	0xb0, 0xe6, 0xf8, 0x5d, 0x5b, 0x14, 0xd2, 0x33, 0x21, 0x44, 0x4f, 0x20, 0x3f, 0x48, 0x6c, 0x00,
	0x4c, 0x70, 0x60, 0x2e, 0x90, 0x07, 0xd0, 0x7f, 0xc3, 0xbd, 0x8e, 0x47, 0x7a, 0xb6, 0xdb, 0xa5,
	0xc6, 0x04, 0x27, 0xc9, 0x39, 0xab, 0x01, 0x60, 0x3f, 0xcc, 0x2d, 0xfd, 0xa4, 0xc0, 0xc6, 0xcc,
	0x5e, 0xf7, 0xe3, 0x95, 0xb3, 0xa1, 0xd1, 0xea, 0x52, 0x46, 0x3c, 0x9e, 0xc6, 0x79, 0xbc, 0x28,
	0xa4, 0x7b, 0x42, 0xe8, 0x0f, 0x44, 0x71, 0xdf, 0x64, 0x86, 0x12, 0x38, 0xc5, 0xbf, 0x35, 0x0b,
	0xfd, 0x13, 0xe6, 0x07, 0x1b, 0xe5, 0x16, 0x33, 0x63, 0x08, 0x2e, 0x7d, 0x4c, 0xc0, 0xda, 0xf4,
	0xab, 0x80, 0xd6, 0x61, 0x5e, 0xd6, 0xd8, 0xb6, 0x64, 0x54, 0x69, 0x21, 0xd0, 0x2c, 0xf4, 0x0e,
	0xd0, 0x8d, 0xeb, 0x5d, 0x5f, 0xb6, 0xdc, 0x1b, 0x83, 0x7c, 0x20, 0x8d, 0x2e, 0x6f, 0x81, 0x18,
	0x77, 0xff, 0x38, 0xb2, 0x50, 0xef, 0x25, 0xbc, 0x16, 0xa0, 0xf1, 0xd2, 0xcd, 0xb8, 0x08, 0x15,
	0x20, 0x15, 0xa4, 0x36, 0xce, 0x53, 0x1b, 0x7c, 0xa2, 0x87, 0x90, 0xa1, 0x8d, 0x26, 0xb1, 0xba,
	0x2d, 0xc2, 0xb3, 0x20, 0xca, 0xba, 0x30, 0x90, 0x69, 0x16, 0x52, 0x21, 0x3b, 0x84, 0xf0, 0x11,
	0x9a, 0xf8, 0x6c, 0x3a, 0x16, 0x07, 0x0c, 0x3e, 0x43, 0x37, 0x00, 0x28, 0x33, 0x3d, 0x26, 0x7c,
	0x88, 0xea, 0xce, 0x4b, 0x89, 0x66, 0xa1, 0xff, 0x42, 0x26, 0x50, 0x73, 0xfb, 0xa9, 0xcf, 0xda,
	0x5f, 0x90, 0x78, 0x6e, 0xfd, 0x7f, 0xb0, 0xcc, 0x37, 0x62, 0x93, 0x98, 0x1e, 0xbb, 0x20, 0x26,
	0x13, 0x56, 0xd2, 0x9f, 0xb5, 0xb2, 0xe4, 0xd3, 0x0e, 0x02, 0x16, 0xb7, 0xf5, 0x0f, 0x48, 0x59,
	0x84, 0x99, 0x76, 0x8b, 0x16, 0xe6, 0x39, 0xff, 0x7e, 0x64, 0xd6, 0x4f, 0xcd, 0x7e, 0xcb, 0x35,
	0x2d, 0x1c, 0x80, 0xfd, 0x0c, 0x9b, 0x8c, 0x91, 0x76, 0x87, 0x15, 0x40, 0x34, 0x92, 0xfc, 0x44,
	0xaf, 0x20, 0xc3, 0xa3, 0xf3, 0x9b, 0xbc, 0xeb, 0x91, 0xc2, 0xc2, 0x0c, 0xb3, 0xfb, 0x02, 0x83,
	0x17, 0x7c, 0x86, 0xfc, 0x40, 0xcf, 0x60, 0x85, 0x1b, 0xf0, 0xcb, 0x4a, 0x3c, 0xc3, 0xb6, 0x88,
	0xc3, 0x6c, 0xd6, 0x2f, 0x64, 0x78, 0xef, 0x20, 0x5f, 0xf7, 0x9e, 0xab, 0x34, 0xa9, 0x41, 0x27,
	0x90, 0x93, 0xf5, 0x35, 0xe4, 0x08, 0x2c, 0x2c, 0x46, 0xb5, 0xd0, 0x70, 0x8a, 0xc8, 0x9b, 0x25,
	0x67, 0x29, 0xce, 0xf6, 0x42, 0xdf, 0xa5, 0xef, 0xe2, 0xb0, 0x3a, 0x65, 0xce, 0xa2, 0x55, 0x48,
	0x05, 0xfb, 0x57, 0xe1, 0x85, 0x4d, 0x32, 0xb1, 0x79, 0x43, 0x8d, 0x1e, 0xbb, 0x55, 0xa3, 0xc7,
	0xbf, 0xb6, 0xd1, 0xbf, 0x81, 0xbf, 0x8c, 0x9d, 0xdc, 0xb0, 0x19, 0x69, 0xfb, 0xbb, 0xda, 0x7f,
	0x76, 0xed, 0xdc, 0xee, 0xfc, 0x1a, 0x23, 0x6d, 0xbc, 0xdc, 0x9b, 0x90, 0x51, 0xf4, 0x12, 0x92,
	0xa4, 0x47, 0x1c, 0x16, 0xac, 0xe2, 0x8d, 0xe8, 0xe1, 0x69, 0x32, 0xf3, 0x75, 0xcb, 0xbd, 0xc0,
	0x12, 0x8c, 0xf6, 0x20, 0xeb, 0x90, 0x1b, 0xc3, 0xeb, 0x3a, 0x86, 0xa4, 0x27, 0x6f, 0x43, 0xcf,
	0x38, 0xe4, 0x06, 0x77, 0x9d, 0x1a, 0xa7, 0x94, 0x7e, 0x56, 0xa0, 0x30, 0x6d, 0xf9, 0xcc, 0x9e,
	0x2a, 0x51, 0x63, 0x39, 0x16, 0x3d, 0x96, 0xbf, 0xf6, 0xb9, 0x54, 0xfa, 0x5e, 0x81, 0xe5, 0x70,
	0x94, 0xba, 0x7b, 0x4d, 0x1c, 0x3f, 0xc0, 0x60, 0xd4, 0x8a, 0x47, 0x70, 0x02, 0xa7, 0xe5, 0xac,
	0xa5, 0xe8, 0x1c, 0x72, 0x63, 0x0b, 0x59, 0xce, 0xbc, 0x2f, 0xde, 0xc2, 0x38, 0x1b, 0xde, 0xc1,
	0xa5, 0x5f, 0xc3, 0x8f, 0x73, 0xfe, 0x2a, 0x74, 0x2e, 0xdd, 0x3f, 0x65, 0x0c, 0xaf, 0x8f, 0xbe,
	0x7d, 0xe3, 0x7c, 0x4c, 0x0c, 0x9f, 0xb3, 0x23, 0xf7, 0x68, 0x2e, 0x74, 0x8f, 0x46, 0x86, 0x77,
	0x22, 0x3c, 0xbc, 0x37, 0x21, 0x7b, 0x69, 0x7b, 0x94, 0x89, 0xa6, 0x1a, 0x8e, 0xd6, 0x0c, 0x97,
	0xf2, 0xb6, 0xd1, 0x2c, 0x54, 0x82, 0x45, 0x87, 0x7c, 0x18, 0x01, 0xa5, 0xc4, 0x8c, 0xf7, 0x85,
	0x01, 0x66, 0x7c, 0x0d, 0xa4, 0x27, 0xd6, 0x80, 0xdf, 0x7e, 0xf9, 0xd1, 0x44, 0xf2, 0xaa, 0x8e,
	0x2e, 0x50, 0x25, 0xbc, 0x40, 0xbf, 0xe2, 0xff, 0x94, 0x80, 0xda, 0xf1, 0xdc, 0x06, 0xa1, 0x34,
	0x4c, 0x8d, 0x0f, 0xa9, 0xa7, 0x81, 0x7e, 0x40, 0x2d, 0xbd, 0x81, 0xdc, 0xd8, 0xcb, 0x20, 0xbc,
	0xc9, 0x95, 0x2f, 0xd8, 0xe4, 0x3b, 0x1f, 0x27, 0x7b, 0x87, 0x97, 0xea, 0x21, 0x6c, 0xe0, 0xda,
	0xe9, 0xa1, 0xb6, 0xa7, 0xea, 0xda, 0xc9, 0xb1, 0xa1, 0xab, 0xf5, 0x37, 0x86, 0x7e, 0x7e, 0x5a,
	0x33, 0xb4, 0xe3, 0x33, 0xf5, 0x50, 0xab, 0xe6, 0xef, 0xa0, 0x22, 0xdc, 0x8f, 0x86, 0x54, 0x4f,
	0x8e, 0x54, 0xed, 0x38, 0xaf, 0x4c, 0x37, 0x72, 0xa0, 0xd5, 0xf5, 0x13, 0x7c, 0x9e, 0x8f, 0xa1,
	0xa7, 0xb0, 0x15, 0x0d, 0xa9, 0x9f, 0x1f, 0xef, 0x19, 0xf5, 0x03, 0x15, 0x57, 0x8d, 0xba, 0xae,
	0xea, 0xef, 0xea, 0xf9, 0x38, 0xda, 0x82, 0xbf, 0xcd, 0x00, 0xab, 0x7b, 0xba, 0x76, 0xa6, 0xe9,
	0xe7, 0xf9, 0x39, 0xb4, 0x03, 0x8f, 0x67, 0x3a, 0x36, 0x8e, 0x6a, 0xba, 0x5a, 0x55, 0x75, 0x35,
	0x9f, 0x40, 0x9b, 0x50, 0x9c, 0x8d, 0x3d, 0xdb, 0xcd, 0x27, 0xd1, 0x13, 0x78, 0x14, 0x8d, 0xda,
	0x57, 0xb5, 0xc3, 0x93, 0xb3, 0x1a, 0x36, 0x8e, 0x54, 0xfc, 0xa6, 0x86, 0xf3, 0xa9, 0x1d, 0x1b,
	0x72, 0x63, 0x2f, 0x56, 0x74, 0x1f, 0x0a, 0x22, 0x29, 0xc6, 0xc9, 0x69, 0x0d, 0x0b, 0x13, 0xc3,
	0x44, 0xae, 0xc3, 0xea, 0x84, 0x76, 0x0f, 0xd7, 0x54, 0xbd, 0x96, 0x57, 0x22, 0x95, 0xef, 0x4e,
	0xab, 0xbe, 0x32, 0xb6, 0x73, 0x0c, 0xa9, 0xea, 0xe1, 0x5b, 0x5e, 0xb0, 0x15, 0xc8, 0x57, 0x0f,
	0xdf, 0x8e, 0xd7, 0xa8, 0x00, 0x2b, 0x03, 0xe9, 0x48, 0xfc, 0x79, 0x05, 0x2d, 0x43, 0x6e, 0xa0,
	0x91, 0x05, 0x8b, 0xbd, 0xde, 0xfb, 0xed, 0xd3, 0x03, 0xe5, 0xe3, 0xa7, 0x07, 0xca, 0xef, 0x9f,
	0x1e, 0x28, 0xff, 0x7f, 0x79, 0x65, 0xb3, 0x66, 0xf7, 0xa2, 0xdc, 0x70, 0xdb, 0x95, 0xd0, 0xaf,
	0x04, 0xe5, 0x2b, 0xe2, 0x88, 0x5f, 0x25, 0x86, 0x3f, 0x18, 0xfc, 0x47, 0xfc, 0xd5, 0x7b, 0x7e,
	0x91, 0xe4, 0x9a, 0x17, 0x7f, 0x04, 0x00, 0x00, 0xff, 0xff, 0xc8, 0x16, 0xd1, 0xe8, 0x01, 0x11,
	0x00, 0x00,
}

func (m *ReplicationMessages) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *ReplicationMessages) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ReplicationMessages) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.XXX_unrecognized != nil {
		i -= len(m.XXX_unrecognized)
		copy(dAtA[i:], m.XXX_unrecognized)
	}
	if m.SyncShardStatus != nil {
		{
			size, err := m.SyncShardStatus.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x22
	}
	if m.HasMore {
		i--
		if m.HasMore {
			dAtA[i] = 1
		} else {
			dAtA[i] = 0
		}
		i--
		dAtA[i] = 0x18
	}
	if m.LastRetrievedMessageId != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.LastRetrievedMessageId))
		i--
		dAtA[i] = 0x10
	}
	if len(m.ReplicationTasks) > 0 {
		for iNdEx := len(m.ReplicationTasks) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.ReplicationTasks[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintReplication(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0xa
		}
	}
	return len(dAtA) - i, nil
}

func (m *ReplicationTask) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *ReplicationTask) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ReplicationTask) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.XXX_unrecognized != nil {
		i -= len(m.XXX_unrecognized)
		copy(dAtA[i:], m.XXX_unrecognized)
	}
	if m.Attributes != nil {
		{
			size := m.Attributes.Size()
			i -= size
			if _, err := m.Attributes.MarshalTo(dAtA[i:]); err != nil {
				return 0, err
			}
		}
	}
	if m.CreationTime != nil {
		{
			size, err := m.CreationTime.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x1a
	}
	if m.SourceTaskId != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.SourceTaskId))
		i--
		dAtA[i] = 0x10
	}
	if m.TaskType != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.TaskType))
		i--
		dAtA[i] = 0x8
	}
	return len(dAtA) - i, nil
}

func (m *ReplicationTask_DomainTaskAttributes) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ReplicationTask_DomainTaskAttributes) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	if m.DomainTaskAttributes != nil {
		{
			size, err := m.DomainTaskAttributes.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x22
	}
	return len(dAtA) - i, nil
}
func (m *ReplicationTask_SyncShardStatusTaskAttributes) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ReplicationTask_SyncShardStatusTaskAttributes) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	if m.SyncShardStatusTaskAttributes != nil {
		{
			size, err := m.SyncShardStatusTaskAttributes.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x2a
	}
	return len(dAtA) - i, nil
}
func (m *ReplicationTask_SyncActivityTaskAttributes) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ReplicationTask_SyncActivityTaskAttributes) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	if m.SyncActivityTaskAttributes != nil {
		{
			size, err := m.SyncActivityTaskAttributes.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x32
	}
	return len(dAtA) - i, nil
}
func (m *ReplicationTask_HistoryTaskV2Attributes) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ReplicationTask_HistoryTaskV2Attributes) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	if m.HistoryTaskV2Attributes != nil {
		{
			size, err := m.HistoryTaskV2Attributes.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x3a
	}
	return len(dAtA) - i, nil
}
func (m *ReplicationTask_FailoverMarkerAttributes) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ReplicationTask_FailoverMarkerAttributes) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	if m.FailoverMarkerAttributes != nil {
		{
			size, err := m.FailoverMarkerAttributes.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x42
	}
	return len(dAtA) - i, nil
}
func (m *DomainTaskAttributes) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *DomainTaskAttributes) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *DomainTaskAttributes) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.XXX_unrecognized != nil {
		i -= len(m.XXX_unrecognized)
		copy(dAtA[i:], m.XXX_unrecognized)
	}
	if m.PreviousFailoverVersion != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.PreviousFailoverVersion))
		i--
		dAtA[i] = 0x30
	}
	if m.FailoverVersion != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.FailoverVersion))
		i--
		dAtA[i] = 0x28
	}
	if m.ConfigVersion != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.ConfigVersion))
		i--
		dAtA[i] = 0x20
	}
	if m.Domain != nil {
		{
			size, err := m.Domain.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x1a
	}
	if len(m.Id) > 0 {
		i -= len(m.Id)
		copy(dAtA[i:], m.Id)
		i = encodeVarintReplication(dAtA, i, uint64(len(m.Id)))
		i--
		dAtA[i] = 0x12
	}
	if m.DomainOperation != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.DomainOperation))
		i--
		dAtA[i] = 0x8
	}
	return len(dAtA) - i, nil
}

func (m *SyncShardStatusTaskAttributes) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *SyncShardStatusTaskAttributes) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *SyncShardStatusTaskAttributes) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.XXX_unrecognized != nil {
		i -= len(m.XXX_unrecognized)
		copy(dAtA[i:], m.XXX_unrecognized)
	}
	if m.Timestamp != nil {
		{
			size, err := m.Timestamp.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x1a
	}
	if m.ShardId != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.ShardId))
		i--
		dAtA[i] = 0x10
	}
	if len(m.SourceCluster) > 0 {
		i -= len(m.SourceCluster)
		copy(dAtA[i:], m.SourceCluster)
		i = encodeVarintReplication(dAtA, i, uint64(len(m.SourceCluster)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *SyncActivityTaskAttributes) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *SyncActivityTaskAttributes) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *SyncActivityTaskAttributes) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.XXX_unrecognized != nil {
		i -= len(m.XXX_unrecognized)
		copy(dAtA[i:], m.XXX_unrecognized)
	}
	if m.VersionHistory != nil {
		{
			size, err := m.VersionHistory.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x6a
	}
	if len(m.LastWorkerIdentity) > 0 {
		i -= len(m.LastWorkerIdentity)
		copy(dAtA[i:], m.LastWorkerIdentity)
		i = encodeVarintReplication(dAtA, i, uint64(len(m.LastWorkerIdentity)))
		i--
		dAtA[i] = 0x62
	}
	if m.LastFailure != nil {
		{
			size, err := m.LastFailure.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x5a
	}
	if m.Attempt != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.Attempt))
		i--
		dAtA[i] = 0x50
	}
	if m.Details != nil {
		{
			size, err := m.Details.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x4a
	}
	if m.LastHeartbeatTime != nil {
		{
			size, err := m.LastHeartbeatTime.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x42
	}
	if m.StartedTime != nil {
		{
			size, err := m.StartedTime.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x3a
	}
	if m.StartedId != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.StartedId))
		i--
		dAtA[i] = 0x30
	}
	if m.ScheduledTime != nil {
		{
			size, err := m.ScheduledTime.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x2a
	}
	if m.ScheduledId != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.ScheduledId))
		i--
		dAtA[i] = 0x20
	}
	if m.Version != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.Version))
		i--
		dAtA[i] = 0x18
	}
	if m.WorkflowExecution != nil {
		{
			size, err := m.WorkflowExecution.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x12
	}
	if len(m.DomainId) > 0 {
		i -= len(m.DomainId)
		copy(dAtA[i:], m.DomainId)
		i = encodeVarintReplication(dAtA, i, uint64(len(m.DomainId)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *HistoryTaskV2Attributes) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *HistoryTaskV2Attributes) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *HistoryTaskV2Attributes) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.XXX_unrecognized != nil {
		i -= len(m.XXX_unrecognized)
		copy(dAtA[i:], m.XXX_unrecognized)
	}
	if m.NewRunEvents != nil {
		{
			size, err := m.NewRunEvents.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x32
	}
	if m.Events != nil {
		{
			size, err := m.Events.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x2a
	}
	if len(m.VersionHistoryItems) > 0 {
		for iNdEx := len(m.VersionHistoryItems) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.VersionHistoryItems[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintReplication(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0x22
		}
	}
	if m.WorkflowExecution != nil {
		{
			size, err := m.WorkflowExecution.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x1a
	}
	if len(m.DomainId) > 0 {
		i -= len(m.DomainId)
		copy(dAtA[i:], m.DomainId)
		i = encodeVarintReplication(dAtA, i, uint64(len(m.DomainId)))
		i--
		dAtA[i] = 0x12
	}
	if m.TaskId != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.TaskId))
		i--
		dAtA[i] = 0x8
	}
	return len(dAtA) - i, nil
}

func (m *FailoverMarkerAttributes) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *FailoverMarkerAttributes) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *FailoverMarkerAttributes) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.XXX_unrecognized != nil {
		i -= len(m.XXX_unrecognized)
		copy(dAtA[i:], m.XXX_unrecognized)
	}
	if m.CreationTime != nil {
		{
			size, err := m.CreationTime.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x1a
	}
	if m.FailoverVersion != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.FailoverVersion))
		i--
		dAtA[i] = 0x10
	}
	if len(m.DomainId) > 0 {
		i -= len(m.DomainId)
		copy(dAtA[i:], m.DomainId)
		i = encodeVarintReplication(dAtA, i, uint64(len(m.DomainId)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *FailoverMarkerToken) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *FailoverMarkerToken) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *FailoverMarkerToken) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.XXX_unrecognized != nil {
		i -= len(m.XXX_unrecognized)
		copy(dAtA[i:], m.XXX_unrecognized)
	}
	if m.FailoverMarker != nil {
		{
			size, err := m.FailoverMarker.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x12
	}
	if len(m.ShardIds) > 0 {
		dAtA23 := make([]byte, len(m.ShardIds)*10)
		var j22 int
		for _, num1 := range m.ShardIds {
			num := uint64(num1)
			for num >= 1<<7 {
				dAtA23[j22] = uint8(uint64(num)&0x7f | 0x80)
				num >>= 7
				j22++
			}
			dAtA23[j22] = uint8(num)
			j22++
		}
		i -= j22
		copy(dAtA[i:], dAtA23[:j22])
		i = encodeVarintReplication(dAtA, i, uint64(j22))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *ReplicationTaskInfo) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *ReplicationTaskInfo) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ReplicationTaskInfo) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.XXX_unrecognized != nil {
		i -= len(m.XXX_unrecognized)
		copy(dAtA[i:], m.XXX_unrecognized)
	}
	if m.ScheduledId != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.ScheduledId))
		i--
		dAtA[i] = 0x40
	}
	if m.NextEventId != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.NextEventId))
		i--
		dAtA[i] = 0x38
	}
	if m.FirstEventId != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.FirstEventId))
		i--
		dAtA[i] = 0x30
	}
	if m.Version != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.Version))
		i--
		dAtA[i] = 0x28
	}
	if m.TaskId != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.TaskId))
		i--
		dAtA[i] = 0x20
	}
	if m.TaskType != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.TaskType))
		i--
		dAtA[i] = 0x18
	}
	if m.WorkflowExecution != nil {
		{
			size, err := m.WorkflowExecution.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x12
	}
	if len(m.DomainId) > 0 {
		i -= len(m.DomainId)
		copy(dAtA[i:], m.DomainId)
		i = encodeVarintReplication(dAtA, i, uint64(len(m.DomainId)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *ReplicationToken) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *ReplicationToken) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ReplicationToken) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.XXX_unrecognized != nil {
		i -= len(m.XXX_unrecognized)
		copy(dAtA[i:], m.XXX_unrecognized)
	}
	if m.LastProcessedMessageId != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.LastProcessedMessageId))
		i--
		dAtA[i] = 0x18
	}
	if m.LastRetrievedMessageId != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.LastRetrievedMessageId))
		i--
		dAtA[i] = 0x10
	}
	if m.ShardId != 0 {
		i = encodeVarintReplication(dAtA, i, uint64(m.ShardId))
		i--
		dAtA[i] = 0x8
	}
	return len(dAtA) - i, nil
}

func (m *SyncShardStatus) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *SyncShardStatus) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *SyncShardStatus) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.XXX_unrecognized != nil {
		i -= len(m.XXX_unrecognized)
		copy(dAtA[i:], m.XXX_unrecognized)
	}
	if m.Timestamp != nil {
		{
			size, err := m.Timestamp.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReplication(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func encodeVarintReplication(dAtA []byte, offset int, v uint64) int {
	offset -= sovReplication(v)
	base := offset
	for v >= 1<<7 {
		dAtA[offset] = uint8(v&0x7f | 0x80)
		v >>= 7
		offset++
	}
	dAtA[offset] = uint8(v)
	return base
}
func (m *ReplicationMessages) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if len(m.ReplicationTasks) > 0 {
		for _, e := range m.ReplicationTasks {
			l = e.Size()
			n += 1 + l + sovReplication(uint64(l))
		}
	}
	if m.LastRetrievedMessageId != 0 {
		n += 1 + sovReplication(uint64(m.LastRetrievedMessageId))
	}
	if m.HasMore {
		n += 2
	}
	if m.SyncShardStatus != nil {
		l = m.SyncShardStatus.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.XXX_unrecognized != nil {
		n += len(m.XXX_unrecognized)
	}
	return n
}

func (m *ReplicationTask) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.TaskType != 0 {
		n += 1 + sovReplication(uint64(m.TaskType))
	}
	if m.SourceTaskId != 0 {
		n += 1 + sovReplication(uint64(m.SourceTaskId))
	}
	if m.CreationTime != nil {
		l = m.CreationTime.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.Attributes != nil {
		n += m.Attributes.Size()
	}
	if m.XXX_unrecognized != nil {
		n += len(m.XXX_unrecognized)
	}
	return n
}

func (m *ReplicationTask_DomainTaskAttributes) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.DomainTaskAttributes != nil {
		l = m.DomainTaskAttributes.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	return n
}
func (m *ReplicationTask_SyncShardStatusTaskAttributes) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.SyncShardStatusTaskAttributes != nil {
		l = m.SyncShardStatusTaskAttributes.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	return n
}
func (m *ReplicationTask_SyncActivityTaskAttributes) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.SyncActivityTaskAttributes != nil {
		l = m.SyncActivityTaskAttributes.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	return n
}
func (m *ReplicationTask_HistoryTaskV2Attributes) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.HistoryTaskV2Attributes != nil {
		l = m.HistoryTaskV2Attributes.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	return n
}
func (m *ReplicationTask_FailoverMarkerAttributes) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.FailoverMarkerAttributes != nil {
		l = m.FailoverMarkerAttributes.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	return n
}
func (m *DomainTaskAttributes) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.DomainOperation != 0 {
		n += 1 + sovReplication(uint64(m.DomainOperation))
	}
	l = len(m.Id)
	if l > 0 {
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.Domain != nil {
		l = m.Domain.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.ConfigVersion != 0 {
		n += 1 + sovReplication(uint64(m.ConfigVersion))
	}
	if m.FailoverVersion != 0 {
		n += 1 + sovReplication(uint64(m.FailoverVersion))
	}
	if m.PreviousFailoverVersion != 0 {
		n += 1 + sovReplication(uint64(m.PreviousFailoverVersion))
	}
	if m.XXX_unrecognized != nil {
		n += len(m.XXX_unrecognized)
	}
	return n
}

func (m *SyncShardStatusTaskAttributes) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.SourceCluster)
	if l > 0 {
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.ShardId != 0 {
		n += 1 + sovReplication(uint64(m.ShardId))
	}
	if m.Timestamp != nil {
		l = m.Timestamp.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.XXX_unrecognized != nil {
		n += len(m.XXX_unrecognized)
	}
	return n
}

func (m *SyncActivityTaskAttributes) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.DomainId)
	if l > 0 {
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.WorkflowExecution != nil {
		l = m.WorkflowExecution.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.Version != 0 {
		n += 1 + sovReplication(uint64(m.Version))
	}
	if m.ScheduledId != 0 {
		n += 1 + sovReplication(uint64(m.ScheduledId))
	}
	if m.ScheduledTime != nil {
		l = m.ScheduledTime.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.StartedId != 0 {
		n += 1 + sovReplication(uint64(m.StartedId))
	}
	if m.StartedTime != nil {
		l = m.StartedTime.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.LastHeartbeatTime != nil {
		l = m.LastHeartbeatTime.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.Details != nil {
		l = m.Details.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.Attempt != 0 {
		n += 1 + sovReplication(uint64(m.Attempt))
	}
	if m.LastFailure != nil {
		l = m.LastFailure.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	l = len(m.LastWorkerIdentity)
	if l > 0 {
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.VersionHistory != nil {
		l = m.VersionHistory.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.XXX_unrecognized != nil {
		n += len(m.XXX_unrecognized)
	}
	return n
}

func (m *HistoryTaskV2Attributes) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.TaskId != 0 {
		n += 1 + sovReplication(uint64(m.TaskId))
	}
	l = len(m.DomainId)
	if l > 0 {
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.WorkflowExecution != nil {
		l = m.WorkflowExecution.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if len(m.VersionHistoryItems) > 0 {
		for _, e := range m.VersionHistoryItems {
			l = e.Size()
			n += 1 + l + sovReplication(uint64(l))
		}
	}
	if m.Events != nil {
		l = m.Events.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.NewRunEvents != nil {
		l = m.NewRunEvents.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.XXX_unrecognized != nil {
		n += len(m.XXX_unrecognized)
	}
	return n
}

func (m *FailoverMarkerAttributes) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.DomainId)
	if l > 0 {
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.FailoverVersion != 0 {
		n += 1 + sovReplication(uint64(m.FailoverVersion))
	}
	if m.CreationTime != nil {
		l = m.CreationTime.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.XXX_unrecognized != nil {
		n += len(m.XXX_unrecognized)
	}
	return n
}

func (m *FailoverMarkerToken) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if len(m.ShardIds) > 0 {
		l = 0
		for _, e := range m.ShardIds {
			l += sovReplication(uint64(e))
		}
		n += 1 + sovReplication(uint64(l)) + l
	}
	if m.FailoverMarker != nil {
		l = m.FailoverMarker.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.XXX_unrecognized != nil {
		n += len(m.XXX_unrecognized)
	}
	return n
}

func (m *ReplicationTaskInfo) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.DomainId)
	if l > 0 {
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.WorkflowExecution != nil {
		l = m.WorkflowExecution.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.TaskType != 0 {
		n += 1 + sovReplication(uint64(m.TaskType))
	}
	if m.TaskId != 0 {
		n += 1 + sovReplication(uint64(m.TaskId))
	}
	if m.Version != 0 {
		n += 1 + sovReplication(uint64(m.Version))
	}
	if m.FirstEventId != 0 {
		n += 1 + sovReplication(uint64(m.FirstEventId))
	}
	if m.NextEventId != 0 {
		n += 1 + sovReplication(uint64(m.NextEventId))
	}
	if m.ScheduledId != 0 {
		n += 1 + sovReplication(uint64(m.ScheduledId))
	}
	if m.XXX_unrecognized != nil {
		n += len(m.XXX_unrecognized)
	}
	return n
}

func (m *ReplicationToken) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.ShardId != 0 {
		n += 1 + sovReplication(uint64(m.ShardId))
	}
	if m.LastRetrievedMessageId != 0 {
		n += 1 + sovReplication(uint64(m.LastRetrievedMessageId))
	}
	if m.LastProcessedMessageId != 0 {
		n += 1 + sovReplication(uint64(m.LastProcessedMessageId))
	}
	if m.XXX_unrecognized != nil {
		n += len(m.XXX_unrecognized)
	}
	return n
}

func (m *SyncShardStatus) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.Timestamp != nil {
		l = m.Timestamp.Size()
		n += 1 + l + sovReplication(uint64(l))
	}
	if m.XXX_unrecognized != nil {
		n += len(m.XXX_unrecognized)
	}
	return n
}

func sovReplication(x uint64) (n int) {
	return (math_bits.Len64(x|1) + 6) / 7
}
func sozReplication(x uint64) (n int) {
	return sovReplication(uint64((x << 1) ^ uint64((int64(x) >> 63))))
}
func (m *ReplicationMessages) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReplication
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: ReplicationMessages: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: ReplicationMessages: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ReplicationTasks", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ReplicationTasks = append(m.ReplicationTasks, &ReplicationTask{})
			if err := m.ReplicationTasks[len(m.ReplicationTasks)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field LastRetrievedMessageId", wireType)
			}
			m.LastRetrievedMessageId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.LastRetrievedMessageId |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 3:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field HasMore", wireType)
			}
			var v int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				v |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			m.HasMore = bool(v != 0)
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field SyncShardStatus", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.SyncShardStatus == nil {
				m.SyncShardStatus = &SyncShardStatus{}
			}
			if err := m.SyncShardStatus.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipReplication(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			m.XXX_unrecognized = append(m.XXX_unrecognized, dAtA[iNdEx:iNdEx+skippy]...)
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *ReplicationTask) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReplication
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: ReplicationTask: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: ReplicationTask: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field TaskType", wireType)
			}
			m.TaskType = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.TaskType |= ReplicationTaskType(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field SourceTaskId", wireType)
			}
			m.SourceTaskId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.SourceTaskId |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field CreationTime", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.CreationTime == nil {
				m.CreationTime = &types.Timestamp{}
			}
			if err := m.CreationTime.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field DomainTaskAttributes", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			v := &DomainTaskAttributes{}
			if err := v.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			m.Attributes = &ReplicationTask_DomainTaskAttributes{v}
			iNdEx = postIndex
		case 5:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field SyncShardStatusTaskAttributes", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			v := &SyncShardStatusTaskAttributes{}
			if err := v.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			m.Attributes = &ReplicationTask_SyncShardStatusTaskAttributes{v}
			iNdEx = postIndex
		case 6:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field SyncActivityTaskAttributes", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			v := &SyncActivityTaskAttributes{}
			if err := v.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			m.Attributes = &ReplicationTask_SyncActivityTaskAttributes{v}
			iNdEx = postIndex
		case 7:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field HistoryTaskV2Attributes", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			v := &HistoryTaskV2Attributes{}
			if err := v.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			m.Attributes = &ReplicationTask_HistoryTaskV2Attributes{v}
			iNdEx = postIndex
		case 8:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field FailoverMarkerAttributes", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			v := &FailoverMarkerAttributes{}
			if err := v.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			m.Attributes = &ReplicationTask_FailoverMarkerAttributes{v}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipReplication(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			m.XXX_unrecognized = append(m.XXX_unrecognized, dAtA[iNdEx:iNdEx+skippy]...)
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *DomainTaskAttributes) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReplication
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: DomainTaskAttributes: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: DomainTaskAttributes: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field DomainOperation", wireType)
			}
			m.DomainOperation = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.DomainOperation |= DomainOperation(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Id", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Id = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Domain", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.Domain == nil {
				m.Domain = &v1.Domain{}
			}
			if err := m.Domain.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 4:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field ConfigVersion", wireType)
			}
			m.ConfigVersion = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.ConfigVersion |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 5:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field FailoverVersion", wireType)
			}
			m.FailoverVersion = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.FailoverVersion |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 6:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field PreviousFailoverVersion", wireType)
			}
			m.PreviousFailoverVersion = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.PreviousFailoverVersion |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		default:
			iNdEx = preIndex
			skippy, err := skipReplication(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			m.XXX_unrecognized = append(m.XXX_unrecognized, dAtA[iNdEx:iNdEx+skippy]...)
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *SyncShardStatusTaskAttributes) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReplication
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: SyncShardStatusTaskAttributes: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: SyncShardStatusTaskAttributes: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field SourceCluster", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.SourceCluster = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field ShardId", wireType)
			}
			m.ShardId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.ShardId |= int32(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Timestamp", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.Timestamp == nil {
				m.Timestamp = &types.Timestamp{}
			}
			if err := m.Timestamp.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipReplication(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			m.XXX_unrecognized = append(m.XXX_unrecognized, dAtA[iNdEx:iNdEx+skippy]...)
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *SyncActivityTaskAttributes) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReplication
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: SyncActivityTaskAttributes: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: SyncActivityTaskAttributes: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field DomainId", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.DomainId = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field WorkflowExecution", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.WorkflowExecution == nil {
				m.WorkflowExecution = &v1.WorkflowExecution{}
			}
			if err := m.WorkflowExecution.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 3:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field Version", wireType)
			}
			m.Version = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.Version |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 4:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field ScheduledId", wireType)
			}
			m.ScheduledId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.ScheduledId |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 5:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ScheduledTime", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.ScheduledTime == nil {
				m.ScheduledTime = &types.Timestamp{}
			}
			if err := m.ScheduledTime.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 6:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field StartedId", wireType)
			}
			m.StartedId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.StartedId |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 7:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field StartedTime", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.StartedTime == nil {
				m.StartedTime = &types.Timestamp{}
			}
			if err := m.StartedTime.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 8:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field LastHeartbeatTime", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.LastHeartbeatTime == nil {
				m.LastHeartbeatTime = &types.Timestamp{}
			}
			if err := m.LastHeartbeatTime.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 9:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Details", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.Details == nil {
				m.Details = &v1.Payload{}
			}
			if err := m.Details.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 10:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field Attempt", wireType)
			}
			m.Attempt = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.Attempt |= int32(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 11:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field LastFailure", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.LastFailure == nil {
				m.LastFailure = &v1.Failure{}
			}
			if err := m.LastFailure.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 12:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field LastWorkerIdentity", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.LastWorkerIdentity = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 13:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field VersionHistory", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.VersionHistory == nil {
				m.VersionHistory = &VersionHistory{}
			}
			if err := m.VersionHistory.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipReplication(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			m.XXX_unrecognized = append(m.XXX_unrecognized, dAtA[iNdEx:iNdEx+skippy]...)
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *HistoryTaskV2Attributes) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReplication
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: HistoryTaskV2Attributes: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: HistoryTaskV2Attributes: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field TaskId", wireType)
			}
			m.TaskId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.TaskId |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field DomainId", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.DomainId = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field WorkflowExecution", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.WorkflowExecution == nil {
				m.WorkflowExecution = &v1.WorkflowExecution{}
			}
			if err := m.WorkflowExecution.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field VersionHistoryItems", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.VersionHistoryItems = append(m.VersionHistoryItems, &VersionHistoryItem{})
			if err := m.VersionHistoryItems[len(m.VersionHistoryItems)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 5:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Events", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.Events == nil {
				m.Events = &v1.DataBlob{}
			}
			if err := m.Events.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 6:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field NewRunEvents", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.NewRunEvents == nil {
				m.NewRunEvents = &v1.DataBlob{}
			}
			if err := m.NewRunEvents.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipReplication(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			m.XXX_unrecognized = append(m.XXX_unrecognized, dAtA[iNdEx:iNdEx+skippy]...)
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *FailoverMarkerAttributes) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReplication
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: FailoverMarkerAttributes: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: FailoverMarkerAttributes: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field DomainId", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.DomainId = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field FailoverVersion", wireType)
			}
			m.FailoverVersion = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.FailoverVersion |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field CreationTime", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.CreationTime == nil {
				m.CreationTime = &types.Timestamp{}
			}
			if err := m.CreationTime.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipReplication(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			m.XXX_unrecognized = append(m.XXX_unrecognized, dAtA[iNdEx:iNdEx+skippy]...)
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *FailoverMarkerToken) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReplication
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: FailoverMarkerToken: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: FailoverMarkerToken: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType == 0 {
				var v int32
				for shift := uint(0); ; shift += 7 {
					if shift >= 64 {
						return ErrIntOverflowReplication
					}
					if iNdEx >= l {
						return io.ErrUnexpectedEOF
					}
					b := dAtA[iNdEx]
					iNdEx++
					v |= int32(b&0x7F) << shift
					if b < 0x80 {
						break
					}
				}
				m.ShardIds = append(m.ShardIds, v)
			} else if wireType == 2 {
				var packedLen int
				for shift := uint(0); ; shift += 7 {
					if shift >= 64 {
						return ErrIntOverflowReplication
					}
					if iNdEx >= l {
						return io.ErrUnexpectedEOF
					}
					b := dAtA[iNdEx]
					iNdEx++
					packedLen |= int(b&0x7F) << shift
					if b < 0x80 {
						break
					}
				}
				if packedLen < 0 {
					return ErrInvalidLengthReplication
				}
				postIndex := iNdEx + packedLen
				if postIndex < 0 {
					return ErrInvalidLengthReplication
				}
				if postIndex > l {
					return io.ErrUnexpectedEOF
				}
				var elementCount int
				var count int
				for _, integer := range dAtA[iNdEx:postIndex] {
					if integer < 128 {
						count++
					}
				}
				elementCount = count
				if elementCount != 0 && len(m.ShardIds) == 0 {
					m.ShardIds = make([]int32, 0, elementCount)
				}
				for iNdEx < postIndex {
					var v int32
					for shift := uint(0); ; shift += 7 {
						if shift >= 64 {
							return ErrIntOverflowReplication
						}
						if iNdEx >= l {
							return io.ErrUnexpectedEOF
						}
						b := dAtA[iNdEx]
						iNdEx++
						v |= int32(b&0x7F) << shift
						if b < 0x80 {
							break
						}
					}
					m.ShardIds = append(m.ShardIds, v)
				}
			} else {
				return fmt.Errorf("proto: wrong wireType = %d for field ShardIds", wireType)
			}
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field FailoverMarker", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.FailoverMarker == nil {
				m.FailoverMarker = &FailoverMarkerAttributes{}
			}
			if err := m.FailoverMarker.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipReplication(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			m.XXX_unrecognized = append(m.XXX_unrecognized, dAtA[iNdEx:iNdEx+skippy]...)
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *ReplicationTaskInfo) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReplication
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: ReplicationTaskInfo: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: ReplicationTaskInfo: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field DomainId", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.DomainId = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field WorkflowExecution", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.WorkflowExecution == nil {
				m.WorkflowExecution = &v1.WorkflowExecution{}
			}
			if err := m.WorkflowExecution.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 3:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field TaskType", wireType)
			}
			m.TaskType = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.TaskType |= int32(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 4:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field TaskId", wireType)
			}
			m.TaskId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.TaskId |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 5:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field Version", wireType)
			}
			m.Version = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.Version |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 6:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field FirstEventId", wireType)
			}
			m.FirstEventId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.FirstEventId |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 7:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field NextEventId", wireType)
			}
			m.NextEventId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.NextEventId |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 8:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field ScheduledId", wireType)
			}
			m.ScheduledId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.ScheduledId |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		default:
			iNdEx = preIndex
			skippy, err := skipReplication(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			m.XXX_unrecognized = append(m.XXX_unrecognized, dAtA[iNdEx:iNdEx+skippy]...)
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *ReplicationToken) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReplication
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: ReplicationToken: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: ReplicationToken: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field ShardId", wireType)
			}
			m.ShardId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.ShardId |= int32(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field LastRetrievedMessageId", wireType)
			}
			m.LastRetrievedMessageId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.LastRetrievedMessageId |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 3:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field LastProcessedMessageId", wireType)
			}
			m.LastProcessedMessageId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.LastProcessedMessageId |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		default:
			iNdEx = preIndex
			skippy, err := skipReplication(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			m.XXX_unrecognized = append(m.XXX_unrecognized, dAtA[iNdEx:iNdEx+skippy]...)
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *SyncShardStatus) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReplication
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: SyncShardStatus: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: SyncShardStatus: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Timestamp", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReplication
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReplication
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.Timestamp == nil {
				m.Timestamp = &types.Timestamp{}
			}
			if err := m.Timestamp.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipReplication(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) < 0 {
				return ErrInvalidLengthReplication
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			m.XXX_unrecognized = append(m.XXX_unrecognized, dAtA[iNdEx:iNdEx+skippy]...)
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func skipReplication(dAtA []byte) (n int, err error) {
	l := len(dAtA)
	iNdEx := 0
	depth := 0
	for iNdEx < l {
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return 0, ErrIntOverflowReplication
			}
			if iNdEx >= l {
				return 0, io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		wireType := int(wire & 0x7)
		switch wireType {
		case 0:
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				iNdEx++
				if dAtA[iNdEx-1] < 0x80 {
					break
				}
			}
		case 1:
			iNdEx += 8
		case 2:
			var length int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowReplication
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				length |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if length < 0 {
				return 0, ErrInvalidLengthReplication
			}
			iNdEx += length
		case 3:
			depth++
		case 4:
			if depth == 0 {
				return 0, ErrUnexpectedEndOfGroupReplication
			}
			depth--
		case 5:
			iNdEx += 4
		default:
			return 0, fmt.Errorf("proto: illegal wireType %d", wireType)
		}
		if iNdEx < 0 {
			return 0, ErrInvalidLengthReplication
		}
		if depth == 0 {
			return iNdEx, nil
		}
	}
	return 0, io.ErrUnexpectedEOF
}

var (
	ErrInvalidLengthReplication        = fmt.Errorf("proto: negative length found during unmarshaling")
	ErrIntOverflowReplication          = fmt.Errorf("proto: integer overflow")
	ErrUnexpectedEndOfGroupReplication = fmt.Errorf("proto: unexpected end of group")
)
